Index: code/branches/FICN/src/orxonox/Flocking.h
===================================================================
--- code/branches/FICN/src/orxonox/Flocking.h	(revision 707)
+++ code/branches/FICN/src/orxonox/Flocking.h	(revision 708)
@@ -5,19 +5,15 @@
 #define _Flocking_H__
 
-// #include <Ogre.h>
-#include <OgreVector3.h>
+#include "misc/Vector3.h"
 
-
-#include <iostream>
-
-
-
-class Element // An element that flocks
+namespace orxonox
 {
+  class Element // An element that flocks
+  {
 
   public:
-    Ogre::Vector3 location;                       //!< locationvector of the element
-    Ogre::Vector3 speed;                          //!< speedvector of the element
-    Ogre::Vector3 acceleration;                   //!< accelerationvector of the element
+    Vector3 location;                       //!< locationvector of the element
+    Vector3 speed;                          //!< speedvector of the element
+    Vector3 acceleration;                   //!< accelerationvector of the element
     bool movable;                                 //!< movability of the element, (false) gives the possiblity that an object can`t be moved by flocking but still gets into the calculation
     static int const SEPERATIONDISTANCE = 300;    //!< detectionradius of seperation
@@ -26,118 +22,119 @@
     static int const ANZELEMENTS = 9;             //!< number of elements
 
-  //! default constructor
-  Element() {
-    acceleration = Ogre::Vector3(0,0,0);
-    speed = Ogre::Vector3(0,0,0);
-    location = Ogre::Vector3(0,0,0);
-    movable = true;
-  }
+    //! default constructor
+    Element() {
+      acceleration = Vector3(0,0,0);
+      speed = Vector3(0,0,0);
+      location = Vector3(0,0,0);
+      movable = true;
+    }
 
-  /** constructor
-   *  @param location_ sets locationvector of the element
-   *  @param speed_ sets speedvector of the element
-   *  @param acceleration_ sets accelerationvector of the element
-   *  @param movable_ sets movability of the element
-   */
-  Element(Ogre::Vector3 location_, Ogre::Vector3 speed_, Ogre::Vector3 acceleration_, bool movable_) {
-    acceleration = acceleration_;
-    speed = speed_;
-    location = location_;
-    movable = movable_;
-  }
+    /** constructor
+    *  @param location_ sets locationvector of the element
+    *  @param speed_ sets speedvector of the element
+    *  @param acceleration_ sets accelerationvector of the element
+    *  @param movable_ sets movability of the element
+    */
+    Element(Vector3 location_, Vector3 speed_, Vector3 acceleration_, bool movable_) {
+      acceleration = acceleration_;
+      speed = speed_;
+      location = location_;
+      movable = movable_;
+    }
 
-  //! function to chance values of an element
-  void setValues(Ogre::Vector3 location_, Ogre::Vector3 speed_, Ogre::Vector3 acceleration_, bool movable_) {
-    acceleration = acceleration_;
-    speed = speed_;
-    location = location_;
-    movable = movable_;
-  }
+    //! function to chance values of an element
+    void setValues(Vector3 location_, Vector3 speed_, Vector3 acceleration_, bool movable_) {
+      acceleration = acceleration_;
+      speed = speed_;
+      location = location_;
+      movable = movable_;
+    }
 
-  /** calculates the distance between the element and an other point given by temp
-   * @param e remote object to calculate distance to
-   */
-  float getDistance(Element e) {
-    Ogre::Vector3 distance = e.location - location;
-    return distance.length();
-  }
+    /** calculates the distance between the element and an other point given by temp
+    * @param e remote object to calculate distance to
+    */
+    float getDistance(Element e) {
+      Vector3 distance = e.location - location;
+      return distance.length();
+    }
 
-  //! updates the data of an element
-  void update(Element arrayOfElements[]) {
-    if (this->movable == true) {calculateAcceleration(arrayOfElements);} //if element is movable, calculate acceleration
-  }
+    //! updates the data of an element
+    void update(Element arrayOfElements[]) {
+      if (this->movable == true) {calculateAcceleration(arrayOfElements);} //if element is movable, calculate acceleration
+    }
 
-  //! calculates the new acceleration of an element
-  void calculateAcceleration(Element arrayOfElements[]) {
-    acceleration = separation(arrayOfElements) + alignment(arrayOfElements) + cohesion(arrayOfElements);  //acceleration consisting of flocking-functions
-  }
+    //! calculates the new acceleration of an element
+    void calculateAcceleration(Element arrayOfElements[]) {
+      acceleration = separation(arrayOfElements) + alignment(arrayOfElements) + cohesion(arrayOfElements);  //acceleration consisting of flocking-functions
+    }
 
-  //! separation-function (keep elements separated, avoid crashs)
-  Ogre::Vector3 separation(Element arrayOfElements[]) {
-    using namespace Ogre;
-    Vector3 steering = Vector3(0,0,0); //steeringvector
-    Vector3 inverseDistance = Vector3(0,0,0);  //vector pointing away from possible collisions
-    int numberOfNeighbour = 0;  //number of observed neighbours
-    float distance = 0;  // distance to the actual element
-    for(int i=0; i<ANZELEMENTS; i++) {  //go through all elements
-      Element actual = arrayOfElements[i];  //get the actual element
-      distance = getDistance(actual);  //get distance between this and actual
-      if ((distance > 0) && (distance < SEPERATIONDISTANCE)) {  //do only if actual is inside detectionradius
-        inverseDistance = (0,0,0);
-        inverseDistance = location-actual.location;  //calculate the distancevector heading towards this
-        //adaptation of the inverseDistance to the distance
-        if ((distance < 200) && (distance >= 120)) {inverseDistance = 2*inverseDistance;}
-        if ((distance < 120) && (distance >= 80)) {inverseDistance = 5*inverseDistance;}
-        if ((distance < 80) && (distance >= 40)) {inverseDistance = 10*inverseDistance;}
-        if ((distance < 40) && (distance > 0)) {inverseDistance = 10*inverseDistance;}
-        steering = steering + inverseDistance;  //add up all significant steeringvectors
-        numberOfNeighbour++;  //counts the elements inside the detectionradius
+    //! separation-function (keep elements separated, avoid crashs)
+    Vector3 separation(Element arrayOfElements[]) {
+      using namespace Ogre;
+      Vector3 steering = Vector3(0,0,0); //steeringvector
+      Vector3 inverseDistance = Vector3(0,0,0);  //vector pointing away from possible collisions
+      int numberOfNeighbour = 0;  //number of observed neighbours
+      float distance = 0;  // distance to the actual element
+      for(int i=0; i<ANZELEMENTS; i++) {  //go through all elements
+        Element actual = arrayOfElements[i];  //get the actual element
+        distance = getDistance(actual);  //get distance between this and actual
+        if ((distance > 0) && (distance < SEPERATIONDISTANCE)) {  //do only if actual is inside detectionradius
+          inverseDistance = (0,0,0);
+          inverseDistance = location-actual.location;  //calculate the distancevector heading towards this
+          //adaptation of the inverseDistance to the distance
+          if ((distance < 200) && (distance >= 120)) {inverseDistance = 2*inverseDistance;}
+          if ((distance < 120) && (distance >= 80)) {inverseDistance = 5*inverseDistance;}
+          if ((distance < 80) && (distance >= 40)) {inverseDistance = 10*inverseDistance;}
+          if ((distance < 40) && (distance > 0)) {inverseDistance = 10*inverseDistance;}
+          steering = steering + inverseDistance;  //add up all significant steeringvectors
+          numberOfNeighbour++;  //counts the elements inside the detectionradius
+        }
       }
+      if(numberOfNeighbour > 0) { steering = steering / (float)numberOfNeighbour; }  //devide the sum of steeringvectors by the number of elements -> separation steeringvector
+      return steering;
     }
-    if(numberOfNeighbour > 0) { steering = steering / (float)numberOfNeighbour; }  //devide the sum of steeringvectors by the number of elements -> separation steeringvector
-    return steering;
-  }
 
-  //! alignment-function (lead elements to the same heading)
-  Ogre::Vector3 alignment(Element arrayOfElements[]) {
-    using namespace Ogre;
-    Vector3 steering = Vector3(0,0,0); //steeringvector
-    int numberOfNeighbour = 0;  //number of observed neighbours
-    float distance = 0;
-    //go through all elements
-    for(int i=0; i<ANZELEMENTS; i++) {  //just working with 3 elements at the moment
-      Element actual = arrayOfElements[i];  //get the actual element
-      float distance = getDistance(actual);  //get distance between this and actual
-      if ((distance > 0) && (distance < ALIGNMENTDISTANCE)) {  //check if actual element is inside detectionradius
-        steering = steering + actual.speed;  //add up all speedvectors inside the detectionradius
-        numberOfNeighbour++;  //counts the elements inside the detectionradius
+    //! alignment-function (lead elements to the same heading)
+    Vector3 alignment(Element arrayOfElements[]) {
+      using namespace Ogre;
+      Vector3 steering = Vector3(0,0,0); //steeringvector
+      int numberOfNeighbour = 0;  //number of observed neighbours
+      float distance = 0;
+      //go through all elements
+      for(int i=0; i<ANZELEMENTS; i++) {  //just working with 3 elements at the moment
+        Element actual = arrayOfElements[i];  //get the actual element
+        float distance = getDistance(actual);  //get distance between this and actual
+        if ((distance > 0) && (distance < ALIGNMENTDISTANCE)) {  //check if actual element is inside detectionradius
+          steering = steering + actual.speed;  //add up all speedvectors inside the detectionradius
+          numberOfNeighbour++;  //counts the elements inside the detectionradius
+        }
       }
+      if(numberOfNeighbour > 0) { steering = steering / (float)numberOfNeighbour; }  //devide the sum of steeringvectors by the number of elements -> alignment steeringvector
+      return steering;
     }
-    if(numberOfNeighbour > 0) { steering = steering / (float)numberOfNeighbour; }  //devide the sum of steeringvectors by the number of elements -> alignment steeringvector
-    return steering;
-  }
 
-  //! cohseion-function (keep elements close to each other)
-  Ogre::Vector3 cohesion(Element arrayOfElements[]) {
-    using namespace Ogre;
-    Vector3 steering = Vector3(0,0,0); //steeringvector
-    int numberOfNeighbour = 0;  //number of observed neighbours
-    float distance = 0;
-    //go through all elements
-    for(int i=0; i<ANZELEMENTS; i++) {  //just working with 3 elements at the moment
-      Element actual = arrayOfElements[i];  //get the actual element
-      float distance = getDistance(actual);  //get distance between this and actual
-      if ((distance > 0) && (distance < COHESIONDISTANCE)) {  //check if actual element is inside detectionradius
-        steering = steering + actual.location;  //add up all locations of elements inside the detectionradius
-        numberOfNeighbour++;  //counts the elements inside the detectionradius
+    //! cohseion-function (keep elements close to each other)
+    Vector3 cohesion(Element arrayOfElements[]) {
+      using namespace Ogre;
+      Vector3 steering = Vector3(0,0,0); //steeringvector
+      int numberOfNeighbour = 0;  //number of observed neighbours
+      float distance = 0;
+      //go through all elements
+      for(int i=0; i<ANZELEMENTS; i++) {  //just working with 3 elements at the moment
+        Element actual = arrayOfElements[i];  //get the actual element
+        float distance = getDistance(actual);  //get distance between this and actual
+        if ((distance > 0) && (distance < COHESIONDISTANCE)) {  //check if actual element is inside detectionradius
+          steering = steering + actual.location;  //add up all locations of elements inside the detectionradius
+          numberOfNeighbour++;  //counts the elements inside the detectionradius
+        }
       }
+      if(numberOfNeighbour > 0) {
+        steering = steering  / (float)numberOfNeighbour;  //devide the sum steeringvector by the number of elements -> cohesion steeringvector
+        steering = steering - this->location;  //transform the vector for the ship
+      }
+      return steering;
     }
-    if(numberOfNeighbour > 0) {
-      steering = steering  / (float)numberOfNeighbour;  //devide the sum steeringvector by the number of elements -> cohesion steeringvector
-      steering = steering - this->location;  //transform the vector for the ship
-    }
-    return steering;
-  }
-};     //End of class Element
+  };     //End of class Element
+}
 
 #endif /* _Flocking_H__*/
Index: code/branches/FICN/src/orxonox/GraphicsEngine.cc
===================================================================
--- code/branches/FICN/src/orxonox/GraphicsEngine.cc	(revision 707)
+++ code/branches/FICN/src/orxonox/GraphicsEngine.cc	(revision 708)
@@ -65,7 +65,7 @@
 #endif*/
 #if defined(_DEBUG) && defined(WIN32)
-    std::string plugin_filename = "plugins_d.cfg";
+    String plugin_filename = "plugins_d.cfg";
 #else
-    std::string plugin_filename = "plugins.cfg";
+    String plugin_filename = "plugins.cfg";
 #endif
     root_ = new Root(plugin_filename);
@@ -100,5 +100,5 @@
   }
 
-  void GraphicsEngine::loadRessourceLocations(std::string dataPath)
+  void GraphicsEngine::loadRessourceLocations(String dataPath)
   {
     //TODO: Specify layout of data file and maybe use xml-loader
Index: code/branches/FICN/src/orxonox/GraphicsEngine.h
===================================================================
--- code/branches/FICN/src/orxonox/GraphicsEngine.h	(revision 707)
+++ code/branches/FICN/src/orxonox/GraphicsEngine.h	(revision 708)
@@ -11,4 +11,6 @@
 #include <OgreSceneManager.h>
 
+#include "misc/String.h"
+
 
 namespace orxonox {
@@ -20,10 +22,10 @@
     public:
       GraphicsEngine();
-      inline void setConfigPath(std::string path) { this->configPath_ = path; };
+      inline void setConfigPath(String path) { this->configPath_ = path; };
       // find a better way for this
       inline Ogre::Root* getRoot() { return root_; };
       void setup();
       bool load();
-      void loadRessourceLocations(std::string path);
+      void loadRessourceLocations(String path);
       Ogre::SceneManager* getSceneManager();
       void startRender();
@@ -32,6 +34,6 @@
     private:
       Ogre::Root*         root_;        //!< Ogre's root
-      std::string         configPath_;  //!< path to config file
-      std::string         dataPath_;    //!< path to data file
+      String         configPath_;  //!< path to config file
+      String         dataPath_;    //!< path to data file
       Ogre::SceneManager* scene_;       //!< scene manager of the game
 
Index: code/branches/FICN/src/orxonox/Main.cc
===================================================================
--- code/branches/FICN/src/orxonox/Main.cc	(revision 707)
+++ code/branches/FICN/src/orxonox/Main.cc	(revision 708)
@@ -39,5 +39,4 @@
 
 using namespace orxonox;
-using namespace Ogre;
 #if OGRE_PLATFORM == OGRE_PLATFORM_APPLE
 #include <CoreFoundation/CoreFoundation.h>
Index: code/branches/FICN/src/orxonox/Orxonox.cc
===================================================================
--- code/branches/FICN/src/orxonox/Orxonox.cc	(revision 707)
+++ code/branches/FICN/src/orxonox/Orxonox.cc	(revision 708)
@@ -32,5 +32,4 @@
 
 //****** OGRE ******
-#include <OgreString.h>
 #include <OgreException.h>
 #include <OgreRoot.h>
@@ -47,9 +46,11 @@
 
 //****** STD *******
-#include <string>
 #include <iostream>
 #include <exception>
 
 //***** ORXONOX ****
+//misc
+#include "misc/Sleep.h"
+
 // loader and audio
 #include "loader/LevelLoader.h"
@@ -77,8 +78,6 @@
 namespace orxonox
 {
-  using namespace Ogre;
-
    // put this in a seperate Class or solve the problem in another fashion
-  class OrxListener : public FrameListener
+  class OrxListener : public Ogre::FrameListener
   {
     public:
@@ -90,5 +89,5 @@
       }
 
-      bool frameStarted(const FrameEvent& evt)
+      bool frameStarted(const Ogre::FrameEvent& evt)
       {
         auMan_->update();
@@ -154,12 +153,12 @@
    * @param path path to config (in home dir or something)
    */
-  void Orxonox::init(int argc, char **argv, std::string path)
+  void Orxonox::init(int argc, char **argv, String path)
   {
     //TODO: find config file (assuming executable directory)
     //TODO: read config file
     //TODO: give config file to Ogre
-    std::string mode;
+    String mode;
 //     if(argc>=2)
-//       mode = std::string(argv[1]);
+//       mode = String(argv[1]);
 //     else
 //       mode = "";
@@ -170,15 +169,15 @@
     //mode = "presentation";
     if(ar.errorHandling()) die();
-    if(mode == std::string("server"))
+    if(mode == String("server"))
     {
       serverInit(path);
       mode_ = SERVER;
     }
-    else if(mode == std::string("client"))
+    else if(mode == String("client"))
     {
       clientInit(path);
       mode_ = CLIENT;
     }
-    else if(mode == std::string("presentation"))
+    else if(mode == String("presentation"))
     {
       serverInit(path);
@@ -244,5 +243,5 @@
   }
 
-  void Orxonox::standaloneInit(std::string path)
+  void Orxonox::standaloneInit(String path)
   {
     ogre_->setConfigPath(path);
@@ -263,5 +262,5 @@
   }
 
-  void Orxonox::playableServer(std::string path)
+  void Orxonox::playableServer(String path)
   {
     ogre_->setConfigPath(path);
@@ -297,5 +296,5 @@
   }
 
-  void Orxonox::serverInit(std::string path)
+  void Orxonox::serverInit(String path)
   {
     COUT(2) << "initialising server" << std::endl;
@@ -307,5 +306,5 @@
   }
 
-  void Orxonox::clientInit(std::string path)
+  void Orxonox::clientInit(String path)
   {
     COUT(2) << "initialising client" << std::endl;
@@ -322,5 +321,5 @@
   void Orxonox::defineResources()
   {
-    Ogre::String secName, typeName, archName;
+    String secName, typeName, archName;
     Ogre::ConfigFile cf;
 #if OGRE_PLATFORM == OGRE_PLATFORM_APPLE
@@ -341,7 +340,7 @@
         archName = i->second;
 #if OGRE_PLATFORM == OGRE_PLATFORM_APPLE
-        ResourceGroupManager::getSingleton().addResourceLocation( String(macBundlePath() + "/" + archName), typeName, secName);
+        Ogre::ResourceGroupManager::getSingleton().addResourceLocation( String(macBundlePath() + "/" + archName), typeName, secName);
 #else
-        ResourceGroupManager::getSingleton().addResourceLocation( archName, typeName, secName);
+        Ogre::ResourceGroupManager::getSingleton().addResourceLocation( archName, typeName, secName);
 #endif
       }
@@ -352,5 +351,5 @@
   {
     if (!root_->restoreConfig() && !root_->showConfigDialog())
-      throw Exception(52, "User canceled the config dialog!", "OrxApplication::setupRenderSystem()");
+      throw Ogre::Exception(52, "User canceled the config dialog!", "OrxApplication::setupRenderSystem()");
   }
 
@@ -362,6 +361,6 @@
   void Orxonox::initializeResourceGroups()
   {
-    TextureManager::getSingleton().setDefaultNumMipmaps(5);
-    ResourceGroupManager::getSingleton().initialiseAllResourceGroups();
+    Ogre::TextureManager::getSingleton().setDefaultNumMipmaps(5);
+    Ogre::ResourceGroupManager::getSingleton().initialiseAllResourceGroups();
   }
 
@@ -381,7 +380,7 @@
     loader_->loadLevel();
 
-    Overlay* hudOverlay = OverlayManager::getSingleton().getByName("Orxonox/HUD1.2");
-    hud::HUD* orxonoxHud;
-    orxonoxHud = new hud::HUD();
+    Ogre::Overlay* hudOverlay = Ogre::OverlayManager::getSingleton().getByName("Orxonox/HUD1.2");
+    HUD* orxonoxHud;
+    orxonoxHud = new HUD();
     orxonoxHud->setEnergyValue(20);
     orxonoxHud->setEnergyDistr(20,20,60);
@@ -427,11 +426,11 @@
     // fixes auto repeat problem
     #if defined OIS_LINUX_PLATFORM
-      pl.insert(std::make_pair(std::string("XAutoRepeatOn"), std::string("true")));
+      pl.insert(std::make_pair(String("XAutoRepeatOn"), String("true")));
     #endif
 
-    RenderWindow *win = ogre_->getRoot()->getAutoCreatedWindow();
+      Ogre::RenderWindow *win = ogre_->getRoot()->getAutoCreatedWindow();
     win->getCustomAttribute("WINDOW", &windowHnd);
     windowHndStr << windowHnd;
-    pl.insert(std::make_pair(std::string("WINDOW"), windowHndStr.str()));
+    pl.insert(std::make_pair(String("WINDOW"), windowHndStr.str()));
     inputManager_ = OIS::InputManager::createInputSystem(pl);
 
Index: code/branches/FICN/src/orxonox/Orxonox.h
===================================================================
--- code/branches/FICN/src/orxonox/Orxonox.h	(revision 707)
+++ code/branches/FICN/src/orxonox/Orxonox.h	(revision 708)
@@ -13,4 +13,6 @@
 #include "OrxonoxPrereqs.h"
 #include "loader/LoaderPrereqs.h"
+
+#include "misc/String.h"
 #include "GraphicsEngine.h"
 
@@ -30,5 +32,5 @@
   {
     public:
-      void init(int argc, char **argv, std::string path);
+      void init(int argc, char **argv, String path);
       void start();
       // not sure if this should be private
@@ -46,9 +48,9 @@
       virtual ~Orxonox();
       // init functions
-      void serverInit(std::string path);
-      void clientInit(std::string path);
-      void standaloneInit(std::string path);
+      void serverInit(String path);
+      void clientInit(String path);
+      void standaloneInit(String path);
       // run functions
-      void playableServer(std::string path);
+      void playableServer(String path);
       void standalone();
       void defineResources();
@@ -64,5 +66,5 @@
     private:
       GraphicsEngine*       ogre_;      //!< our dearest graphics engine <3
-      std::string           dataPath_;  //!< path to data
+      String           dataPath_;  //!< path to data
       loader::LevelLoader*  loader_;    //!< level loader builds the scene
       audio::AudioManager*  auMan_;     //!< audio manager
@@ -77,5 +79,5 @@
       // this is used to identify the mode (server/client/...) we're in
       gameMode              mode_;
-      std::string           serverIp_;
+      String           serverIp_;
   };
 }
Index: code/branches/FICN/src/orxonox/OrxonoxPlatform.h
===================================================================
--- code/branches/FICN/src/orxonox/OrxonoxPlatform.h	(revision 707)
+++ code/branches/FICN/src/orxonox/OrxonoxPlatform.h	(revision 708)
@@ -220,5 +220,9 @@
 typedef unsigned char uint8;
 
-}
+#ifdef ORXONOX_DOUBLE_PRECISION
+typedef double Real;
+#else
+typedef float Real;
+#endif
 
 
@@ -270,13 +274,5 @@
 #endif
 
-
-// hack for the usleep/Sleep problem
-#if ORXONOX_PLATFORM == ORXONOX_PLATFORM_WIN32
-#  include <windows.h>
-#  define usleep(x) Sleep((x)/1000)
-#elif ORXONOX_PLATFORM == ORXONOX_PLATFORM_LINUX
-#  include <unistd.h>
-#endif
-
+} /* namespace orxonox */
 
 #endif /* _OrxonoxPlatform_H__ */
Index: code/branches/FICN/src/orxonox/OrxonoxPrereqs.h
===================================================================
--- code/branches/FICN/src/orxonox/OrxonoxPrereqs.h	(revision 707)
+++ code/branches/FICN/src/orxonox/OrxonoxPrereqs.h	(revision 708)
@@ -40,4 +40,18 @@
 class SpaceShipSteering;
 
+// TinyXML
+class TiXmlString;
+class TiXmlOutStream;
+class TiXmlNode;
+class TiXmlHandle;
+class TiXmlDocument;
+class TiXmlElement;
+class TiXmlComment;
+class TiXmlUnknown;
+class TiXmlAttribute;
+class TiXmlText;
+class TiXmlDeclaration;
+class TiXmlParsingData;
+
 namespace orxonox {
   class Ambient;
@@ -70,4 +84,7 @@
   class BarrelGun;
   class WeaponStation;
+
+  class ParticleInterface;
+  class HUD;
 }
 
@@ -77,8 +94,4 @@
   class AudioSource;
   class AudioStream;
-}
-
-namespace hud {
-  class HUD;
 }
 
@@ -112,7 +125,3 @@
 }
 
-namespace particle {
-  class ParticleInterface;
-}
-
 #endif /* _OrxonoxPrereqs_H__ */
